<template lang="pug">
div
  q-header(flat)
    q-toolbar
      q-toolbar-title(v-if="$q.screen.gt.sm") {{ $t('competition_management') }}
      q-space
      //- LocaleSwitcher
      ProfileMenu(:user="user")

    q-tabs.text-white(align="justify", outside-arrows, mobile-arrows)
      q-route-tab(
        exact,
        to="/dashboard/config",
        v-if="isAdmin",
        name="config",
        icon="settings",
        :label="$t('config')"
      )
      q-route-tab(
        exact,
        to="/dashboard/admin",
        v-if="isAdmin",
        name="admin",
        icon="list",
        :label="$t('admin')"
      )
      q-route-tab(
        exact,
        to="/dashboard/moderator",
        v-if="isModerator",
        name="moderation",
        icon="gavel",
        :label="$t('moderation')"
      )
        q-badge(color="blue", floating, v-if="stats.readyformoderation") {{ stats.readyformoderation }}
      //- q-route-tab(
      //-   exact,
      //-   to="/dashboard/transcriber",
      //-   v-if="isTranscriber",
      //-   name="transcription",
      //-   icon="subtitles",
      //-   :label="$t('transcription')"
      //- )
      //-   q-badge(color="red", floating, v-if="stats.readyformanualsubtitle") {{ stats.readyformanualsubtitle }}
      //- q-route-tab(
      //-   exact,
      //-   to="/dashboard/translator",
      //-   v-if="isTranslator",
      //-   name="translation",
      //-   icon="translate",
      //-   :label="$t('translation')"
      //- )
      //-   q-badge(color="red", floating, v-if="stats.readyformanualtranslate") {{ stats.readyformanualtranslate }}
      //- q-route-tab(
      //-   exact,
      //-   to="/dashboard/verifier",
      //-   v-if="isVerifier",
      //-   name="verification",
      //-   icon="verified",
      //-   :label="$t('verification')"
      //- )
      //-   q-badge(color="red", floating, v-if="stats.readyforverify") {{ stats.readyforverify }}

  q-page
    q-tab-panels(v-model="tab", animated)
      q-tab-panel(name="undefined")
        div {{ $t('noaccess') }}
      q-tab-panel(v-if="isAdmin", name="config")
        Config
      q-tab-panel(v-if="isAdmin", name="admin")
        Admin
      q-tab-panel(v-if="isModerator", name="moderator")
        Moderation
      q-tab-panel(v-if="isTranscriber", name="transcriber")
        Transcription
      q-tab-panel(v-if="isTranslator", name="translator")
        Translation
      q-tab-panel(v-if="isVerifier", name="verifier")
        Verification
</template>

<script>
import { mapState } from "vuex";
import { includes, first } from "lodash";
import { db } from "@/db";
import ProfileMenu from "@/components/ProfileMenu.vue";
import LocaleSwitcher from "@/components/LocaleSwitcher.vue";
import Admin from "@/components/dashboard/Admin.vue";
import Moderation from "@/components/dashboard/Moderation.vue";
import Transcription from "@/components/dashboard/Transcription.vue";
import Translation from "@/components/dashboard/Translation.vue";
import Verification from "@/components/dashboard/Verification.vue";
import Config from "@/components/dashboard/Config.vue";

export default {
  name: "Dashboard",
  props: {
    tab: {
      default: "",
    },
  },
  data: () => {
    return {
      stats: {},
    };
  },
  components: {
    ProfileMenu,
    LocaleSwitcher,
    Moderation,
    Transcription,
    Translation,
    Verification,
    Admin,
    Config,
  },
  watch: {
    tab: {
      immediate: true,
      handler() {
        if (this.tab == "") {
          this.$router.push("/dashboard/" + first(this.user.roles));
        }
      },
    },
    user() {
      if (this.user) {
        if (!includes(this.user.roles, this.tab)) {
          this.$router.push("/dashboard/" + first(this.user.roles));
        }
      }
    },
  },
  computed: {
    isModerator() {
      if (!this.user) return false;

      return includes(this.user.roles, "moderator");
    },
    isTranscriber() {
      if (!this.user) return false;

      return includes(this.user.roles, "transcriber");
    },
    isVerifier() {
      if (!this.user) return false;

      return includes(this.user.roles, "verifier");
    },
    isTranslator() {
      if (!this.user) return false;

      return includes(this.user.roles, "translator");
    },
    isAdmin() {
      if (!this.user) return false;

      return includes(this.user.roles, "admin");
    },
    isSuperAdmin() {
      if (!this.user) return false;

      return includes(this.user.roles, "superadmin");
    },
    ...mapState({
      user: (state) => state.user,
    }),
  },
  firestore: {
    stats: db.collection("config").doc("stats"),
  },
};
</script>
